#include <dlfcn.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

void *tf (void *arg)
{
  char libname[] = "./callerN.so";
  libname[8] = (char) (long) arg;
  void *h = dlopen (libname, RTLD_LAZY | RTLD_GLOBAL);
  if (h != NULL)
    {
      char bar[] = "barN";
      bar[3] = (char) (long) arg;
      void (*fn) (void) = dlsym (h, bar);
      if (fn != NULL)
        fn ();
      else
        fprintf (stderr, "dlsym %s failed: %s\n", bar, dlerror ());
      dlclose (h);
    }
  else
    fprintf (stderr, "dlopen %s failed: %s\n", libname, dlerror ());
}

int
main (int argc, char **argv)
{
  pthread_t th[10];
  int i, cnt = 10;
  if (argc > 1)
    cnt = strtoul (argv[1], NULL, 0);
  if (cnt > 10)
    cnt = 10;
#ifdef TEST2
  char libname[] = "./targetpN.so";
  for (i = 0; i < cnt; i++)
    {
      libname[9] = '0' + i;
      dlopen (libname, RTLD_LAZY | RTLD_GLOBAL);
    }
#endif
  for (i = 0; i < cnt; i++)
    if (pthread_create (&th[i], NULL, tf, (void *) (long) ('0' + i)))
      th[i] = (pthread_t) -1;
  for (i = 0; i < cnt; i++)
    if (th[i] != (pthread_t) -1)
      pthread_join (th[i], NULL);
  return 0;
}
